local MouseIsOver, insert = MouseIsOver, table.insert;

local function SetChecked(self, Value, UserInput)
    if self.State ~= Value then
        self.State = Value
        if Value then
            --self.Checkbox.CheckTexture = self.self:FetchTexture(self.Checkbox)
            --self.Checkbox.CheckTexture:SetPoint("CENTER")
            --self.Checkbox.CheckTexture:SetSize(20 - 2*self.self.BorderSize, 20 - 2*self.self.BorderSize)
            self.Checkbox:SetIcon("TexturePath",self.self:GetIcon("CheckMask"),"Rotation",-45,"Zoom",0.4,"HFlip",true,"Theme","Highlight");
            --self.Checkbox.CheckTexture:SetTexCoord(1.4, 0.5, 0.5, 1.4, 0.5, -0.4, -0.4, 0.5)
            --self.self:SetThemedColor(self.Checkbox.CheckTexture,"Highlight")
        elseif not Value then 
            self.Checkbox:SetIcon()
            --self.Checkbox.CheckTexture:Release()
            --self.Checkbox.CheckTexture = nil
        end
        if self.OnChecked and UserInput then
            self.OnChecked(self, self.State)
        end
    end
end

function _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin:CreateCheckbox(Parent)
    local Checkbutton = self:CreateFrame(Parent)

    Checkbutton.Checkbox = self:CreateButton(Checkbutton)
    Checkbutton.Checkbox:SetPoint("TOPLEFT")
    Checkbutton.Checkbox:Size(20, 20)
    Checkbutton.Checkbox:SetThemedBackdrop()
    Checkbutton.Checkbox.ActiveCheck = function()
        return not Checkbutton.Disable
    end

    Checkbutton.Checkbox.OnClick = function(self)
        if not Checkbutton.Disable then
            Checkbutton:SetChecked(not Checkbutton.State, true)
        end
    end

    Checkbutton:SetText("", 11, "Normal",nil,nil, "LEFT")
    Checkbutton.Text1:SetPoint("BOTTOMLEFT", self.BorderSize + self.Padding + Checkbutton.Checkbox:GetWidth(), self.BorderSize + self.Padding)

    Checkbutton.State = false;
    Checkbutton.SetChecked = SetChecked;

    Checkbutton.EnterLeave = function(self, Enter)
        if Enter then
            if self.Checkbox.State ~= "Pushed" and not self.Disable then
                self.Checkbox.State = "MouseOver"
                self.Checkbox:PresetBorders(self.Checkbox.State)
            end
        else
            if self.Checkbox.State ~= "Pushed" and not self.Disable then
                self.Checkbox.State = "Normal"
                self.Checkbox:PresetBorders(self.Checkbox.State)
            end
        end
    end

    Checkbutton.MouseInteraction = function(self, Up)
        if Up then
            if not self.Disable then
                if MouseIsOver(self) then
                    self.Checkbox.State = "MouseOver"
                    self.Checkbox:PresetBorders(self.Checkbox.State)
                    self:SetChecked(not Checkbutton.State, true)
                else
                    self.Checkbox:SetThemedBackdrop("Border")
                    self.Checkbox.State = "Normal"
                    self.Checkbox:PresetBorders(self.Checkbox.State)
                end
            end
        else
            if not self.Disable then
                self.Checkbox.State = "Pushed"
                self.Checkbox:PresetBorders(self.Checkbox.State)
            end
        end
    end
    Checkbutton:MakeInteractable(true);

    return Checkbutton
end
